#include <stdint.h>
#include "resources.h"

uint8_t uv2_get_8bit(uint8_t reg)
{
        uint8_t tempreg = reg;
        uint8_t temp = 0;
        I2C1_Start();
        I2C1_Write(0x10, &tempreg,1,END_MODE_RESTART);
        I2C1_Read(0x10,&temp,1, END_MODE_STOP);
}

uint16_t uv2_get_16bit (uint8_t reg)
{
        uint8_t temp[2] = {0};
        uint16_t retval = 0;
        uint8_t tempreg = reg;

        I2C1_Start();
        I2C1_Write(0x10, &tempreg,1,END_MODE_RESTART);
        I2C1_Read(0x10,temp,2, END_MODE_STOP);
        
        retval = (uint16_t) temp[0];
        retval |= ((uint16_t) temp[1]) << 8;

        return retval;
}

float get_uv_index()
{
         float UVA = 0.0;
         float UVB = 0.0;
         float UVcomp1 = 0.0;
         float UVcomp2 = 0.0;
         float UVD = 0.0;
         float UVAcomp = 0.0;
         float UVBcomp = 0.0;
         float UVI = 0.0;
         float UVAresp = 0.0011;
         float UVBresp = 0.00125;

         float a = 3.33;
         float b = 2.5;
         float c = 3.66;
         float d = 2.75;

         UVA = (float) uv2_get_16bit(0x07);
         UVD = (float) uv2_get_16bit(0x08);
         UVB = (float) uv2_get_16bit(0x09);
         UVcomp1 = (float) uv2_get_16bit(0x0A);
         UVcomp2 = (float) uv2_get_16bit(0x0B);

         UVAcomp = ( UVA - UVD ) - a * ( UVcomp1 - UVD ) - b * ( UVcomp2 - UVD );
         UVBcomp = ( UVB - UVD ) - c * ( UVcomp1 - UVD ) - d * ( UVcomp2 - UVD );

         UVI = ( (UVBcomp * UVBresp) + (UVAcomp * UVAresp) ) / 2;

         return UVI;
}

void InitMCU()
{
    I2C1_Init_Advanced(100000, &_GPIO_MODULE_I2C1_PB67);
    Delay_ms(100);
}

void DrawFrame() {
  TFT_Init_ILI9341_8bit(320, 240);
  TFT_Fill_Screen(CL_WHITE);
  TFT_Set_Pen(CL_BLACK, 1);
  TFT_Line(20, 220, 300, 220);
  TFT_LIne(20,  46, 300,  46);
  TFT_Set_Font(&HandelGothic_BT21x22_Regular, CL_RED, FO_HORIZONTAL);
  TFT_Write_Text("UV2 Click Board Demo", 25, 14);
  TFT_Set_Font(&Verdana12x13_Regular, CL_BLACK, FO_HORIZONTAL);
  TFT_Write_Text("EasyMx PRO v7 for STM32", 19, 223);
  TFT_Set_Font(&Verdana12x13_Regular, CL_RED, FO_HORIZONTAL);
  TFT_Write_Text("www.mikroe.com", 200, 223);
  TFT_Set_Font(&TFT_defaultFont, CL_BLACK, FO_HORIZONTAL);
}

void main()
{
  float uvindex = 0.0;
  char read[3];
  uint16_t read16 = 0;
  int setup[3];
  char txt[20];

  DrawFrame();

  setup[0] = 0x00;
  setup[1] = 0x00;
  setup[2] = 0x00;

  InitMCU();            // Initialize MCU

  I2C1_Start();
  I2C_Write(0x10, setup, 2, END_MODE_STOP);

  while(1)
  {
            uvindex = get_uv_index();
            floattostr(uvindex, txt);

            TFT_Set_Font(&TFT_defaultFont, CL_BLACK, FO_HORIZONTAL);
            TFT_Write_Text(txt, 30, 100);

            delay_ms(500);
            TFT_Set_Font(&TFT_defaultFont, CL_WHITE, FO_HORIZONTAL);
            TFT_Write_Text(txt, 30, 100);
  }

}